package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.MarcaAutobusDAO;
import com.rjconsultores.ventaboletos.entidad.MarcaAutobus;
import com.rjconsultores.ventaboletos.service.MarcaAutobusService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("marcaAutobusService")
public class MarcaAutobusServiceImpl  implements MarcaAutobusService {

    @Autowired
    private MarcaAutobusDAO marcaAutobusDAO;

    public List<MarcaAutobus> obtenerTodos() {
        return marcaAutobusDAO.obtenerTodos();
    }

    public MarcaAutobus obtenerID(Integer id) {
        return marcaAutobusDAO.obtenerID(id);
    }

    @Transactional
    public MarcaAutobus suscribir(MarcaAutobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaAutobusDAO.suscribir(entidad);
    }

    @Transactional
    public MarcaAutobus actualizacion(MarcaAutobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaAutobusDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(MarcaAutobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        marcaAutobusDAO.actualizacion(entidad);
    }
}
